#include <iostream>
#include <cstdlib>
#include <ctime>

using namespace std;

void znajdz_najdluzszy_podciag_niemalejacy(int ciag[], int liczba_wyrazow, int &poczatek_najd_ciagu, int &koniec_najd_ciagu)
{
	poczatek_najd_ciagu = koniec_najd_ciagu = 0;
	int poczatek_sprawdz_ciagu = poczatek_najd_ciagu;
	for(int koniec_sprawdz_ciagu = 1; koniec_sprawdz_ciagu < liczba_wyrazow; koniec_sprawdz_ciagu++)
		if(ciag[koniec_sprawdz_ciagu] >= ciag[koniec_sprawdz_ciagu - 1])		// Mamy ciag niemalejacy
		{
			if(koniec_sprawdz_ciagu - poczatek_sprawdz_ciagu > koniec_najd_ciagu - poczatek_najd_ciagu)	// Znaleziono nowy najdluzszy
			{
				koniec_najd_ciagu = koniec_sprawdz_ciagu;
				poczatek_najd_ciagu = poczatek_sprawdz_ciagu;
			}
		}
		else												    // Koniec ciagu niemalejacego, zaczynamy nowy ciag
			poczatek_sprawdz_ciagu = koniec_sprawdz_ciagu;
}

void Testuj()
{
	const int LICZBA_WYRAZOW = 10;
	int ciag[LICZBA_WYRAZOW];

	// Przygotowanie losowego ciagu i wypisanie go na ekranie
	for(int i=0; i<LICZBA_WYRAZOW; i++)
	{
		ciag[i] = rand() % 10;
		if(i>0)
			cout << " ";
		cout << ciag[i];
	}
	cout << endl;

	int poczatek, koniec;
	znajdz_najdluzszy_podciag_niemalejacy(ciag, LICZBA_WYRAZOW, poczatek, koniec);
	cout << "Poczatek: ciag[" << poczatek << "]=" << ciag[poczatek] <<
			", koniec: ciag[" << koniec << "]=" << ciag[koniec] <<
			", dlugosc ciagu: " << koniec - poczatek + 1 << endl;
}

int main()
{
    srand(time(NULL));
    for(int i=0; i<10; i++)
		Testuj();
}

